package de.dwslab.lecture.wdi.rdf;

import com.hp.hpl.jena.query.Query;
import com.hp.hpl.jena.query.QueryExecution;
import com.hp.hpl.jena.query.QueryExecutionFactory;
import com.hp.hpl.jena.query.QueryFactory;
import com.hp.hpl.jena.query.QuerySolution;
import com.hp.hpl.jena.query.ResultSet;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.vocabulary.RDFS;

public class WDI_20200_RG2_Solution9 {

	public static void main(String[] args) throws Exception {
		// create RDF model
		Model model = ModelFactory.createDefaultModel();
		// fill the model with the data from the file
		model.read("mondial-3.0-europe-countries.rdf");
		// the sparql query to select the second five most populated countries
		String queryString = "SELECT ?country ?label ?population WHERE {?country <"
				+ RDFS.label
				+ "> ?label . ?country <http://www.geonames.org/ontology#population> ?population .} ORDER BY DESC(?population) OFFSET 5 LIMIT 5";
		// create the query
		Query query = QueryFactory.create(queryString);
		QueryExecution qe = QueryExecutionFactory.create(query, model);
		// execute the query
		ResultSet results = qe.execSelect();
		// parse the results
		while (results.hasNext()) {
			QuerySolution sol = results.next();
			System.out.println(sol.get("label").toString() + "\t"
					+ sol.get("country").toString() + "\t"
					+ sol.get("population").asLiteral().getLong());
		}
	}

}
