package de.dwslab.lecture.wdi.xml;

import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class WDI_20200_RG2_Solution5 {

	public static void main(String[] args) throws ParserConfigurationException,
			SAXException, IOException, XPathExpressionException {

		// create the factory
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		// create a new document builder
		DocumentBuilder builder = factory.newDocumentBuilder();
		// parse a document
		Document doc = builder.parse("src/main/resources/mondial-3.0.xml");

		// define an xpath expression
		XPathFactory xpathFactory = XPathFactory.newInstance();
		XPath xpath = xpathFactory.newXPath();
		// select the country nodes of countries which are in Europe and Asia
		XPathExpression expr = xpath
				.compile("/mondial/country[encompassed/@continent=/mondial/continent[@name='Europe']/@id and encompassed/@continent=/mondial/continent[@name='Asia']/@id]");
		NodeList list = (NodeList) expr.evaluate(doc, XPathConstants.NODESET);
		for (int i = 0; i < list.getLength(); i++) {
			System.out.println("New Country ...");
			Node n = (Node) list.item(i);
			NamedNodeMap map = n.getAttributes();
			for (int j = 0; j < map.getLength(); j++) {
				System.out.println(map.item(j).getNodeName() + ":"
						+ map.item(j).getTextContent());
			}
		}
	}

}
